var _excluded = ["value", "onChange", "onPressEnter", "onBlur", "style", "bordered", "presets", "showTime", "format"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { isArr, isBoolean, isString } from "@pisell/utils";
import dayjs from "dayjs";
import React, { forwardRef, useMemo } from "react";
import DatePicker from "../../../../../date-picker";
import { getText } from "../../../../../../locales";
var RangePicker = DatePicker.OldRangePicker;
var defaultFormat = "YYYY-MM-DD HH:mm:ss";
var Edit = function Edit(props, ref) {
  var value = props.value,
    _onChange = props.onChange,
    onPressEnter = props.onPressEnter,
    onBlur = props.onBlur,
    style = props.style,
    bordered = props.bordered,
    presets = props.presets,
    showTime = props.showTime,
    format = props.format,
    others = _objectWithoutProperties(props, _excluded);
  var dayjsVal = useMemo(function () {
    if (isString(value)) {
      return dayjs(value);
    }
    if (isArr(value)) {
      if (value.some(function (item) {
        return !item;
      })) {
        return [];
      }
      return value.map(function (item) {
        return dayjs(item);
      });
    }
    return value;
  }, [value]);
  var rangePresets = [{
    label: getText("table-action-range-picker-presets-today"),
    value: [dayjs().startOf("day"), dayjs().endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-yesterday"),
    value: [dayjs().add(-1, "d").startOf("day"), dayjs().add(-1, "d").endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-last-3-day"),
    value: [dayjs().add(-3, "d").startOf("day"), dayjs().endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-last-7-day"),
    value: [dayjs().add(-7, "d").startOf("day"), dayjs().endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-last-14-day"),
    value: [dayjs().add(-14, "d").startOf("day"), dayjs().endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-last-30-day"),
    value: [dayjs().add(-30, "d").startOf("day"), dayjs().endOf("day")]
  }, {
    label: getText("table-action-range-picker-presets-last-90-day"),
    value: [dayjs().add(-90, "d").startOf("day"), dayjs().endOf("day")]
  }];
  var _showTime = useMemo(function () {
    if (isBoolean(showTime)) {
      return showTime;
    } else if (_typeof(showTime) === "object") {
      return showTime;
    }
    return true;
  }, [showTime]);
  return /*#__PURE__*/React.createElement(RangePicker, _extends({}, others, {
    format: format,
    showTime: _showTime,
    presets: presets || rangePresets,
    ref: ref,
    value: dayjsVal,
    onChange: function onChange(date) {
      _onChange === null || _onChange === void 0 ? void 0 : _onChange(date === null || date === void 0 ? void 0 : date.map(function (item) {
        var _item$format;
        return (item === null || item === void 0 ? void 0 : (_item$format = item.format) === null || _item$format === void 0 ? void 0 : _item$format.call(item, defaultFormat)) || null;
      }));
    },
    onPressEnter: onPressEnter,
    onBlur: onBlur,
    style: _objectSpread({
      width: "220px"
    }, style),
    bordered: bordered,
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    panelRender: function panelRender(dom) {
      // 面板点击时阻止外部toggleEdit
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick(e) {
          return e.stopPropagation();
        }
      }, dom);
    }
  }));
};
export default /*#__PURE__*/forwardRef(Edit);